<template>
  <div class="page-root">
    <v-list two-line>
      <product-list-item v-for="product in products" :key="product.id" :id="product.id">
        <template slot="actions">
          <!-- Edit Product action -->
          <v-btn
            icon
            title="Update Product"
            @click="selectedProduct = product.id; $refs.updateProductDialog.open()"
          >
            <v-icon>mdi-pencil</v-icon>
          </v-btn>
        </template>
      </product-list-item>
    </v-list>

    <!-- Speed Dial -->
    <v-btn
      fixed
      bottom
      right
      fab
      dark
      color="blue"
      title="Create Product"
      @click="selectedProduct = null; $refs.createProductDialog.open()"
    >
      <v-icon>mdi-plus</v-icon>
    </v-btn>

    <update-product-dialog ref="updateProductDialog" :id="selectedProduct"/>
    <create-product-dialog ref="createProductDialog"/>
  </div>
</template>

<script>
import gql from "graphql-tag";
import ProductListItem from "@/components/list-items/ProductListItem";
import CreateProductDialog from "@/components/dialogs/CreateProductDialog";
import UpdateProductDialog from "@/components/dialogs/UpdateProductDialog";

export default {
  name: "products-page",
  components: { ProductListItem, CreateProductDialog, UpdateProductDialog },
  data() {
    return { products: [], selectedProduct: null };
  },
  apollo: {
    products: {
      query: gql`
        query {
          products: listProducts {
            id
          }
        }
      `,
      subscribeToMore: {
        document: gql`
          subscription {
            products: listProducts {
              id
            }
          }
        `
      }
    }
  }
};
</script>

<style lang="scss">
</style>

